/* $Id$ */
#include <libgen.h>
#include "common.h"
#include "error.h"

const char *program_name = NULL;
static void error(int exit_status, const char *mode, const char *message);


void error_set_program_name(const char *path)
{
  if (program_name == NULL) {
    program_name = xstrdup(basename(path));
  }
}

void error_warning(const char *message)
{
  error(-1, "warning", message);
}

void error_error(const char *message)
{
  error(-1, "ERROR", message);
}

void error_fatal(const char *message)
{
  error(EXIT_FAILURE, "FATAL", message);
}

static void error(int exit_status, const char *mode, const char *message)
{
  FILE *fp;

  fp = stderr;
  fprintf(fp, "%s: %s: %s.\n", program_name, mode, message);
  if (exit_status >= 0) {
    exit(exit_status);
  }
}
