/* $Id$ */
#include <stdio.h>
#include <string.h>
#include "common.h"

#define BUF_LEN 1024


int file_read(const char *path, char *data)
{
  FILE *fp;
  size_t count, len;
  char buf[BUF_LEN], *p;

  fp = fopen(path, "r");
  if (fp == NULL) {
    /* error */
    return FALSE;
  }
  p = data;
  count = 0;
  while (TRUE) {
    len = fread(buf, sizeof(char), BUF_LEN, fp);
    if (len < BUF_LEN) {
      if (ferror(fp)) {
        /* error */
        fclose(fp);
        return FALSE;
      }
      if (feof(fp)) {
        break;
      }
    }
    memcpy(p, buf, len);
    p += len;
    count += len;
  }
  if (len > 0) {
    memcpy(p, buf, len);
    count += len;
  }
  fclose(fp);
  return TRUE;
}
#if 0
int file_read(const char *path, char **data, size_t *length)
{
  FILE *fp;
  size_t count, len;
  char buf[BUF_LEN], *p;

  fp = fopen(path, "r");
  if (fp == NULL) {
    /* error */
    return FALSE;
  }
  *data = XMALLOC(char, 1);
  count = 0;
  while (TRUE) {
    len = fread(buf, sizeof(char), BUF_LEN, fp);
    if (len < BUF_LEN) {
      if (ferror(fp)) {
        /* error */
        fclose(fp);
        return FALSE;
      }
      if (feof(fp)) {
        break;
      }
    }
    *data = XREALOC(char, count+len);
    memcpy(*data+count, buf, len);
    count += len;
  }
  if (len > 0) {
    *data = XREALOC(char, count+len);
    memcpy(*data+count, buf, len);
    count += len;
  }
  fclose(fp);
  *length = count;
  return TRUE;
}
#endif

int file_write(const char *path, const char *data, size_t length)
{
  FILE *fp;
  size_t count, len;
  const char *p;

  fp = fopen(path, "w");
  if (fp == NULL) {
    /* error */
    return FALSE;
  }
  p = data;
  count = length;
  while (count > 0) {
    len = fwrite(p, sizeof(char), count, fp);
    if (len < count) {
      if (ferror(fp)) {
        /* error */
        fclose(fp);
        return FALSE;
      }
      if (feof(fp)) {
        /* why? */
        break;
      }
    }
    p += len;
    count -= len;
  }
  fclose(fp);
  return TRUE;
}

long file_size(const char *path)
{
  FILE *fp;
  long l;

  fp = fopen(path, "r");
  if (fp == NULL) {
    /* error */
    return -1;
  }
  fseek(fp, 0L, SEEK_END);
  l = ftell(fp);
  fclose(fp);
  return l;
}
