/* $Id$ */
#if !defined FRAME_H
#define FRAME_H

#include "common.h"

#define TYPE_COMMAND 0x00
#define TYPE_DATA    0x80

typedef struct frame Frame;

enum {
  FRAME_SERIES_END,
  FRAME_SERIES_CONTINUE
};

BEGIN_C_DECLS

Frame *frame_new(size_t size);
void frame_delete(Frame *p);

int frame_check(Frame *p);
size_t frame_length(Frame *p);
size_t frame_size(Frame *p);

unsigned char *frame_buffer(Frame *p);
unsigned char *frame_data_copy(Frame *p, unsigned char *dst);
size_t frame_get_blocklength(Frame *p);
unsigned char frame_get_type(Frame *p);
int frame_series_end(Frame *p);
size_t frame_set_data(Frame *p, unsigned char type, unsigned char *buf, size_t len);

END_C_DECLS

#endif /* !FRAME_H */
