/* $Id$ */
#if !defined FRAME_DATA_H
#define FRAME_DATA_H

#include "common.h"

struct frameData {
  unsigned char type;  /* frame type */
  unsigned char *data; /* pointer to data */
  size_t length;       /* length of data */
};

typedef struct frameData FrameData;

BEGIN_C_DECLS

FrameData *frameData_set_protocol_version_new(void);
FrameData *frameData_set_baudrate_new(int rate);
FrameData *frameData_set_framesize_new(int size);
FrameData *frameData_set_file_new(const char *name);
FrameData *frameData_put_file_new(const char *name, size_t size);
FrameData *frameData_get_file_new(const char *name);
FrameData *frameData_get_file_info_new(void);
FrameData *frameData_get_file_list_new(void);
FrameData *frameData_data_new(const unsigned char *buf, size_t len);
FrameData *frameData_new(unsigned char type, const unsigned char *buf, size_t len);
void frameData_delete(FrameData *p);

END_C_DECLS

#endif /* !FRAME_DATA_H */
