/* $Id$ */
#if !defined PHONE_FILE_H
#define PHONE_FILE_H

#include "common.h"
#include "filelist.h"
#include "fileinfo.h"

typedef struct phoneFile PhoneFile;

BEGIN_C_DECLS

PhoneFile *phoneFile_open(const char *path);
int phoneFile_close(PhoneFile *fp);

int phoneFile_operation_open(PhoneFile *fp, int baudrate, int framesize);
void phoneFile_operation_close(PhoneFile *fp);

int phoneFile_get_file_list(PhoneFile *fp, FileList **list);
int phoneFile_get_file_info(PhoneFile *fp, const char *remote, FileInfo **info);
int phoneFile_get_file(PhoneFile *fp, const char *remote, const char *local);
int phoneFile_put_file(PhoneFile *fp, const char *remote, const char *local);
int phoneFile_delete_file(PhoneFile *fp, const char *remote);
void phoneFile_get_phone_number(PhoneFile *fp, char *buf, size_t n);
int phoneFile_get_receiving_level(PhoneFile *fp);

END_C_DECLS

#endif /* !PHONE_FILE_H */
