/* $Id$ */
#include "common.h"
#include "readline.h"

#if defined ENABLE_READLINE
#include <readline/readline.h>
#include <readline/history.h>
#endif /* ENABLE_READLINE */

#define BUFFER_SIZE 256

static char *buffer = NULL;


char *readLine(const char *prompt)
{
#if defined ENABLE_READLINE
  XFREE(buffer);
  buffer = readline(prompt);
  if ((buffer != NULL) && (*buffer != '\0')) {
    add_history(buffer);
  }
  return buffer;
#else
  if (buffer == NULL) {
    buffer = XMALLOC(char, BUFFER_SIZE);
  }
  fputs(prompt, stdout);
  return fgets(buffer, BUFFER_SIZE, stdin);
#endif /* ENABLE_READLINE */
}
