/* $Id$ */
#if HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include "common.h"
#include "error.h"

void *xmalloc(size_t num)
{
  void *new = malloc(num);
  if (new == NULL) {
    error_fatal("Memory exhausted");
  }
  return new;
}

void *xrealloc(void *p, size_t num)
{
  void *new = NULL;
  if (p == NULL) {
    return xmalloc(num);
  }
  new = realloc(p, num);
  if (new == NULL) {
    error_fatal("Memory exhausted");
  }
  return new;
}

void *xcalloc(size_t num, size_t size)
{
  void *new = xmalloc(num*size);
  memset(new, 0x0, num*size);
  return new;
}
